<script>
	// import response from "./response.sample.json";

	export let wallData;

	const focuswallcolor = "red";
	const selectedwallcolor = "purple";
	const defaultwallcolor = "black";

	$: x_min = wallData&&wallData.walls? Math.min(...wallData.walls.map(
		(wall) => wall.wall.centre - Math.sqrt(wall.wall.radius2)
	)): null;

	$: x_max = wallData&&wallData.walls? Math.max(...wallData.walls.map(
		(wall) => wall.wall.centre + Math.sqrt(wall.wall.radius2)
	)): null;

	$: y_max = wallData&&wallData.walls? Math.max(...wallData.walls.map(
		(wall) => Math.sqrt(wall.wall.radius2)
	)): null;

	// Sort list of walls from largest to smallest
	// (to avoid large circles covering smaller ones)
	$: diagramData = createDiagramData(wallData);

	function createDiagramData(wallData) {
		console.log("creating DiagramData");
		if(wallData && wallData.walls){
			return wallData.walls.sort((a,b) => (a.wall.radius2 < b.wall.radius2));
		}
		return null;
	}

</script>

<p>diagramData: {JSON.stringify(diagramData)} </p>
<div class="container">
	{#if diagramData}
	<div class="svg-container">
		<svg
		  viewBox="{x_min} 0 {x_max-x_min} {y_max}"
		  style="border:solid black 2px">
			{#each diagramData as wall}
			<circle
				cx={wall.wall.centre}
				cy={y_max}
				r={Math.sqrt(wall.wall.radius2)}
				stroke={
					wall.infocus?
					focuswallcolor
					:(
						wall.selected?
						selectedwallcolor
						:defaultwallcolor
					)
				}
				stroke-width={wall.infocus||wall.selected?y_max/100:y_max/1000}
				fill="white"
				on:focus={null}
				on:mouseover={()=>{wall.infocus=true;}}
				on:blur={null}
				on:mouseout={()=>{wall.infocus=false;}}
				on:click={()=>{
					if(!('ontouchstart' in window)){
						// only do this if not a touch device
						wall.selected = wall.selected?
						  false:true
					}
				}}
				class="{wall.selected?'selected':''}"
			/>
			{/each}
		</svg>
	</div>
	<div class="sidebar">
		<h1>SideBar</h1>
		<div class="wall-destabilisers-container">
		{#each diagramData as wall}
		<div
			class="wall-destabilisers
			     {wall.infocus?'infocus':''}
			     {wall.selected?'selected':''}"
			on:click={()=>{
				if(!('ontouchstart' in window)){
					// only do this if not a touch device
					wall.selected = wall.selected?
					  false:true
				}
			}}
			on:focus={null}
			on:mouseover={()=>{wall.infocus=true;}}
			on:blur={null}
			on:mouseout={()=>{wall.infocus=false;}}
		>
		<div>
			<h1>Destabilisers:</h1>
			<ol>
				{#each wall.destabilisers as destabiliser}
				<li>{destabiliser}</li>
				{/each}
			</ol>
		</div>
		</div>
		{/each}
		</div>
	</div>
	{:else}
	<p> There are infinitely many walls </p>
	{/if}
</div>

<style lang="scss">
	svg > circle {
		transition: stroke 0.15s ease-in;
		transition: stroke-width 0.15s linear;
	}

	div.container {
		display: flex;
		width:100%;
		flex-wrap: wrap;
		align-items: stretch;
		justify-content: space-between;

		div.svg-container {
			flex-basis:60%;
			min-width: 300px;
			flex-grow:2;
		}

		div.sidebar {
			overflow: hidden;
			flex-basis:20%;
			display: flex;
			flex-direction: column;
			border: dotted black 1px;
			flex-grow: 3;

			h1 {
				color: purple;
			}

			$labelheight : 1.5em;
			$labelpadding: 0.2em;
			$labelradius: 0.3em;
			$fileborder: 1px; /* "File" border*/
			$transitiontime: 0.35s;
			$focuscolor: red;
			$selectedcolor: purple;
			$defaultcolor: orange;

			div.wall-destabilisers-container{
				flex-grow:1;
				div.wall-destabilisers{
					&::before{
					/* "File label" */
						display: block;
						float: left; /* needed to help them stack side by side */
						background-color:$focuscolor;
						height: $labelheight;
						padding: $labelpadding $labelpadding 0 $labelpadding;
						content: "label";
						border-radius: $labelradius $labelradius 0 0;
						border-width: $fileborder $fileborder 0 $fileborder;
						border-color: black;
						border-style: solid;
						margin-bottom: -$fileborder;
					}

					&:last-child::before{
						margin-left: 5ch;
					}
					margin-top:-$labelheight -$labelpadding; /* needed so "File labels appear side by side */
					width:100%;
					overflow: hidden;
					div{
						/* "File" */
						clear:left; /* needed to clear from the "file label" float prop */
						transition-property: height;
						transition-duration: $transitiontime;
						transition-timing-function: linear;
						transition-delay: $transitiontime;
						/* TODO choose something more appropriate for height */
						/* It cannot have dynamic height*/
						height: 9em;
						background-color: $focuscolor;
						border: $fileborder solid black;
						margin-bottom: -$fileborder;
					}
					&:not(.infocus):not(.selected){
						div{
							transition-delay: 0s;
							height:0;
							background-color: $defaultcolor;
						}
						&::before{
							background-color: $defaultcolor;
						}
					}
				}
			}
		}
	}

</style>
